<?php
/*
Plugin Name: SidebarTabs
Plugin URI: http://www.nghorta.com/plugin-sidebartabs
Description: sidebarTabs allows you to easily widgets into Tabs
Author: Newton Horta
Version: 2.0
Author URI: http://www.nghorta.com

    sidebarTabs is released under the GNU General Public License (GPL)
    http://www.gnu.org/licenses/gpl.txt

	Utiliza parte das instrues do plugin postTabs de autoria de Leo Germani (http://pirex.com.br/wordpress-plugins/post-tabs)
    
*/

function sidebarTabs_init($reset=false){
	if(!get_option("sidebarTabs") || $reset){

		# Load default options
		$options["active_font"] = "#ffffff";
		$options["active_bg"] = "#464646";
		$options["inactive_font"] = "#464646";
		$options["inactive_bg"] = "#969696";
		$options["over_font"] = "#333333";
		$options["over_bg"] = "#e6e7e8";
		$options["line"] = "none";
		$options["height_tabs"] = "26";
		$options["width_icons"] = "39";
		$options["height_icons"] = "32";
		$options["width_sidebar"] = "200";
		$options["unit"] = "px";
		$options["bg_panes"] = "#464646";
		$options["color_links"] = "#c1c1c1";
		$options["color_hover_links"] = "#e18364";
		$options["text_color"] = "#ffffff";
		$options["layout"] = "1";
		$options["width_corner"] = "5";
		$options["typeCorner"] = "0";
		$options["fs"] = "11";
		$options["fw"] = "normal";
		update_option("sidebarTabs", $options);

		$sidebartabs_args = array(
					'before_widget' => "<div id='%1\$s' class='widget %2\$s'>",
					'after_widget' => '</div>',
					'before_title' => "<h2 class='widgettitle widget_title'>",
					'after_title' => "</h2>",
				); 
		update_option('sidebartabs_args', $sidebartabs_args);
	}

}


add_action('init', 'sidebarTabs_textdomain');
function sidebarTabs_textdomain() {
	load_plugin_textdomain('sidebartabs', false, dirname( plugin_basename(__FILE__) ) . '/langs');
}

function get_sidebarTabs($args) {
	global $wp_registered_widgets, $wp_registered_sidebars, $sidebars_widgets, $i_widget;
	$op = '';
	$stab = get_option("sidebartabs_widget");
	$options = get_option("sidebarTabs");
	$widget_options = get_option("widget_sidebarTabs");
	$widget_id = split('-',$args['widget_id']);
	$widget_id = $widget_id[1];
	$abas = $widget_options[$widget_id]['orderSelect'];
	$layout_instance = $widget_options[$widget_id]['layout_instance'];

	if (is_admin()) { 
		$class = $widget_options['classname_admin'];
		$op .= '<h2 class="'.$class.'">' . $widget_options[$widget_id]['title'] . '</h2>';
	}	

	//	$sidebar = $wp_registered_sidebars['sidebar-1'];
	if ($abas) $abas = split(',',$abas);
	else {
		$widget_id = 1;
		$abas[] = '';
	}
	#Print the sidebartabs links

	if ($layout_instance == 1) {	
		$op .= "\n<div class='sb_container'>\n";
		$op .= "   <a class='prev'></a>\n";
		$op .= "   <div class='scrollable scrollable".$widget_id."'>\n";
		$op .= "      <ul id='sidebarTabs_ul".$widget_id."' class='sidebarTabs sidebarTabs".$widget_id."'>\n";
	} else {
		$op .= "\n<div id='accordion'>\n";
//		$op .= "      <ul id='accordion_ul".$widget_id."' class='accordion".$widget_id."'>\n";
	}
	$c_vert = 1;
	if (is_array($stab)) { 
		ksort($stab);
		foreach ($stab as $i => $widget ) {
			if (in_array($i, $abas) || $abas[0] == '') {
				if ($layout_instance == 1) {	
					$title_icons = '';
					if ($options['layout'] == 2 || $options['layout'] == 4) $title_icons = ' title="'.$widget['sidebartabname'].'"';
					$op .= '        <li><a href="#tab'.$i.'" class="sb'.$i.'" id="sb'.$i.'"'. $title_icons.'>'.$widget['sidebartabname']."</a></li>\n";
				}
			}	
		}		
	}
	if ($layout_instance == 1) {	
		$op .= "      </ul>\n";
		$op .= "   </div>\n";
		$op .= "   <a class='next'></a>\n";
		$op .= '   <div class="sidebarTabs_divs sidebarTabs_panes sidebarTabs_divs'.$widget_id.'">'."\n";
	} else {
		if ($c_vert == 1) {
			$c_style1 = ' current';
			$c_style2 = 'style="display:block;"';
		}	
	}	
	if (is_array($stab)) { 
		ksort($stab);
		foreach ($stab as $i => $widget ) {
			if (in_array($i, $abas) || $abas[0] == '') {
				if ($layout_instance == 1) {	
					$op .= '      <div class="tb">'."\n";
				} else {	
					$op .= '   <h4 class="accordion_h4'.$c_style1.'"><span>'.$widget['sidebartabname']."</span></h4>\n";
					$op .= '   <div class="pane" '.$c_style2.'>'."\n";
				}	
				$bw = stripslashes($widget['before_widget']);
				$aw = stripslashes($widget['after_widget']);
				$bt = stripslashes($widget['before_title']);
				$at = stripslashes($widget['after_title']);
	
				$widget_registered = $wp_registered_widgets[$widget['widget']];
				$params = array_merge(
					array( array_merge( array('widget_id' => $widget['widget'], 'widget_name' => $wp_registered_widgets[$widget['widget']]['name']) ) ),
					(array) $wp_registered_widgets[$widget['widget']]['params']
				);
				// Substitute HTML id and class attributes into before_widget
				$classname_ = '';
				foreach ((array)$widget_registered['classname'] as $cn) {
					if (is_string($cn)) $classname_ .= '_' . $cn;
					elseif (is_object($cn)) $classname_ .= '_' . get_class($cn);
				}
				$classname_ = strtolower(ltrim($classname_, '_'));
				$params[0]['before_widget'] = sprintf($bw, $widget['widget'], $classname_);
				$params[0]['after_widget'] = $aw;
				$params[0]['before_title'] = $bt;
				$params[0]['after_title'] = $at;
				$check_widget = $widget['widget'];
				$check_widget = split('-', $check_widget);
				if (isset($check_widget[1]) && is_numeric($check_widget[1])) $params[0]['number'] = $check_widget[1];
				ob_start();
					if ( is_callable( $widget['callback'] ) ) {
						call_user_func_array($widget['callback'], $params);
						$content = ob_get_contents();
					}
				ob_end_clean();
				$op .= $content;
				$op .= "      \n</div>\n\n";
				$c_vert++;
				$c_style1 = '';
				$c_style2 = '';
			}
		}
	}	
	if ($layout_instance == 1) {	
		$op .= "   </div>\n</div>\n";
	} else {
		$op .= "   </div>\n";
	}
	echo $op;

	get_scripts_sidebarTabs($widget_id,$layout_instance);
}

add_action('wp_enqueue_scripts','sidebarTabs_addHeader');

function sidebarTabs_addHeader(){
	$sbto=get_option("sidebarTabs");
	echo "\n".'<!-- Start Of Script Generated By sidebarTabs -->'."\n";
	$style = "<link rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') . "/wp-content/plugins/sidebartabs/styleSidebar.php?active_bg=".$sbto['active_bg']."&amp;line=".$sbto['line']."&amp;inactive_bg=".$sbto['inactive_bg']."&amp;active_font=".$sbto['active_font']."&amp;inactive_font=".$sbto['inactive_font']."&amp;over_font=".$sbto['over_font']."&amp;over_bg=".$sbto['over_bg']."&amp;width_sidebar=".$sbto['width_sidebar']."&amp;unit=".$sbto['unit']."&amp;bg_panes=".$sbto['bg_panes']."&amp;color_links=".$sbto['color_links']."&amp;color_hover_links=".$sbto['color_hover_links']."&amp;text_color=".$sbto['text_color']."&amp;height_tabs=".$sbto['height_tabs']."&amp;layout=".$sbto['layout']."&amp;height_icons=".$sbto['height_icons']."&amp;fw=".$sbto['fw']."&amp;fs=".$sbto['fs']."&amp;ff=".$sbto['ff']."&amp;theme=".get_template()."\" type=\"text/css\" media=\"screen\" />\n";
	$style = str_replace('#','',$style);
   	echo $style;
	$style = '<link rel="stylesheet" href="' . get_bloginfo('wpurl').'/wp-content/plugins/sidebartabs/styleSidebar_icons.php" type="text/css" media="screen" />'."\n";
   	echo $style;
	if (is_admin()) { ?>
		<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/jquery.corner.js"></script>	
		<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/jquery.tools.min.js"></script>	
<?php
	}
	else {
		wp_enqueue_script('jquery');
		wp_enqueue_script('tools', plugins_url('sidebartabs/js/jquery.tools.min.js'), array('jquery'), '1.1.0');
		wp_enqueue_script('corner', plugins_url('sidebartabs/js/jquery.corner.js'), array('jquery'), '2.01');
	}
	echo '<!-- End Of Script Generated By sidebarTabs -->'."\n";
}

add_action('admin_enqueue_scripts', 'sidebarTabs_admin_addHeader');

function sidebarTabs_admin_addHeader($hook_suffix){
	$sidebarTabs_hook_suffix = array('sidebartabs/sidebarTabs_admin.php','sidebartabs/sidebarTabs.php', 'settings_page_sidebarTabs');
	if(in_array($hook_suffix, $sidebarTabs_hook_suffix)) {
		$sb_options=get_option("sidebarTabs");
		$style = "<link rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') . "/wp-content/plugins/sidebartabs/styleSidebar_admin.php?active_bg=".$sb_options['active_bg']."&amp;line=".$sb_options['line']."&amp;inactive_bg=".$sb_options['inactive_bg']."&amp;active_font=".$sb_options['active_font']."&amp;inactive_font=".$sb_options['inactive_font']."&amp;over_font=".$sb_options['over_font']."&amp;over_bg=".$sb_options['over_bg']."&amp;url_list=".get_bloginfo('wpurl')."&amp;bg_panes=".$sb_options['bg_panes']."&amp;text_color=".$sbto['text_color']."\" type=\"text/css\" media=\"screen\" />\n";
		$style = str_replace('#','',$style);
		echo $style;
		wp_enqueue_script('jquery');
		wp_enqueue_script('301a', plugins_url('sidebartabs/js/301a.js'), array('jquery'), '301a');
		wp_enqueue_script('corner', plugins_url('sidebartabs/js/jquery.corner.js'), array('jquery'), '2.01');
	}
}

function sidebarTabs_admin() {
	if (function_exists('add_options_page')) {
		add_options_page('sidebarTabs Options', 'sidebarTabs', 8, basename(__FILE__), 'sidebarTabs_admin_page');
	}
}

function sidebarTabs_admin_page() {
	
	require_once("sidebarTabs_admin.php");

}
### Class: sidebarTabs Widget
 class WP_Widget_sidebarTabs extends WP_Widget {
	// Constructor
	function WP_Widget_sidebarTabs() {
		$widget_ops = array('description' => __('Put widgets into tabbed (scrollable) interface in sidebar', 'sidebartabs'));
		$this->WP_Widget('sidebarTabs', __('sidebarTabs', 'sidebartabs'), $widget_ops);
	}

	// Display Widget
	function widget($args, $instance) {
		extract($args);
		$title = apply_filters('widget_title', esc_attr($instance['title']));
		$exclude = esc_attr($instance['exclude']);
		$orderSelect = esc_attr($instance['orderSelect']);
		$layout_instance = esc_attr($instance['layout_instance']);
		if (!$exclude) echo $before_title . $title . $after_title;
		get_sidebarTabs($args);		
	}

	// When Widget Control Form Is Posted
	function update($new_instance, $old_instance) {
		if (!isset($new_instance['submit'])) {
			return false;
		}
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['exclude'] = strip_tags($new_instance['exclude']);
		$instance['orderSelect'] = strip_tags($new_instance['orderSelect']);
		$instance['layout_instance'] = strip_tags($new_instance['layout_instance']);
		return $instance;
	}

	// DIsplay Widget Control Form
	function form($instance) {
		global $wpdb;
		$instance = wp_parse_args((array) $instance, array('title' => __('Instance 1', 'sidebartabs'), 'exclude' => '', 'orderSelect' => ''));
		$title = esc_attr($instance['title']);
		$exclude = esc_attr($instance['exclude']);
		$orderSelect = esc_attr($instance['orderSelect']);
		$layout_instance = esc_attr($instance['layout_instance']);
?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'sidebartabs'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('exclude'); ?>"><?php _e('Exclude Title:', 'sidebartabs'); ?> <input id="<?php echo $this->get_field_id('exclude'); ?>" name="<?php echo $this->get_field_name('exclude'); ?>" type="checkbox" value="<?php echo $this->get_field_name('exclude'); ?>" <?php echo checked( $exclude, true ); ?>  /></label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('orderSelect'); ?>"><?php _e('Orders sidebarTabs:', 'sidebartabs'); ?> <input class="widefat" id="<?php echo $this->get_field_id('orderSelect'); ?>" name="<?php echo $this->get_field_name('orderSelect'); ?>" type="text" value="<?php echo $orderSelect; ?>" /></label><br />
			<small><?php _e('Seperate mutiple sidebarTabs orders with commas. Leave blank for all.', 'sidebartabs'); ?></small>		</p>
		<p>
			<label for="<?php echo $this->get_field_id('layout_instance'); ?>"><?php _e('Layout of Instance:', 'sidebartabas'); ?>
				<select name="<?php echo $this->get_field_name('layout_instance'); ?>" id="<?php echo $this->get_field_id('layout_instance'); ?>" class="widefat">
					<option value="1"<?php selected('1', $layout_instance); ?>><?php _e('Horizontal', 'sidebartabs'); ?></option>
					<option value="2"<?php selected('2', $layout_instance); ?>><?php _e('Vertical', 'sidebartabs'); ?></option>
				</select>
			</label>
		</p>
		<input type="hidden" id="<?php echo $this->get_field_id('submit'); ?>" name="<?php echo $this->get_field_name('submit'); ?>" value="1" />
<?php
	}
}


### Function: Init sidebarTabs Widget
add_action('widgets_init', 'widget_sidebarTabs_init');
function widget_sidebarTabs_init() {
	register_widget('WP_Widget_sidebarTabs');
}

function get_scripts_sidebarTabs($id_w, $layout_instance='1') {
	$options_script = get_option("sidebarTabs");
?>
<script type='text/javascript'>
/* <![CDATA[ */
jQuery(document).ready(function($){
<?php 
	if ($layout_instance == 1) {
		if (($options_script['layout'] == 1 || $options_script['layout'] == 3) && $options_script['typeCorner']) {
	?>	
		jQuery("ul.sidebarTabs<?php echo $id_w; ?> li a").corner("<?php echo $options_script['typeCorner'].' '.$options_script['width_corner'].'px'; ?>");
	<?php
		}
		if ($options_script['layout'] == 3 || $options_script['layout'] == 4) {
	?>	
		var tabInicial<?php echo $id_w; ?> = jQuery("ul.sidebarTabs<?php echo $id_w; ?> li a:eq(0)").offset().left
		jQuery("ul.sidebarTabs<?php echo $id_w; ?>").tabs("div.sidebarTabs_divs<?php echo $id_w; ?> > .tb");
	// enabling scrollable
		jQuery("div.scrollable<?php echo $id_w; ?>").scrollable({
			onSeek: function(e) { 
				var api = jQuery("ul.sidebarTabs<?php echo $id_w; ?>").tabs(0); 
				api.click(e);
			}, 
			size: 1,
			items: '#sidebarTabs_ul<?php echo $id_w; ?>',
			clickable: true
		}); 
		jQuery("#sidebarTabs_ul<?php echo $id_w; ?> li a").click(function(e) { 
			var apis = jQuery("div.scrollable<?php echo $id_w; ?>").scrollable(0); 
			if (jQuery(this).offset().left>tabInicial<?php echo $id_w; ?>) apis.next(); 
		}); 
	<?php
		} else {
	?>	
		jQuery("ul.sidebarTabs<?php echo $id_w; ?>").tabs("div.sidebarTabs_divs<?php echo $id_w; ?> > .tb");
	<?php
		}
	} else {
	?>
		jQuery("#accordion").tabs("#accordion div.pane", {tabs: 'h4.accordion_h4', effect: 'fade', initialIndex: null});
	<?php
	}	
?>		
});
/* ]]> */
</script>
<?php
}

register_activation_hook( __FILE__, 'sidebarTabs_init' );

//add_action('plugins_loaded', 'registerWidgets');

add_action('admin_menu','sidebarTabs_admin');
?>
